Graphics 800,600,0,2
SetBuffer BackBuffer()
SeedRnd MilliSecs()
AppTitle "Perlenhafen - BCC22 - v1.02"
TFormFilter 0
AutoMidHandle 1
Dim fonts(2)
For i=0 To 2
	fonts(i)=LoadFont("Arial",(i+1)*16,1)
Next
SetFont fonts(1)

Global timer=CreateTimer(50),dir$="Pearl Harbour\"

.load
meldung "LADEN..."

Dim jetimg(1,179),schiffimg(2),wolken(2)
LoadJet(dir+"sp",0)
LoadJet(dir+"g",1)

For i=0 To 2
	schiffimg(i)=LoadImage(dir+"si"+i+".png")
	wolken(i)=LoadImage(dir+"wo"+i+".png")
Next

Global water=LoadImage(dir$+"w.png")
Global spritz=LoadAnimImage(dir+"pl.png",50,23,0,4)
Global rauchimg=LoadImage(dir+"r.png")

Type jet
	Field x#,y#,w,schuss,bomben,timer,leben#,maxleben,fraktion,speed#
End Type
Global jet.jet,player.jet

Type schiff
	Field x,leben#,maxleben,w,h,typ
End Type

Type schuss
	Field x#,y#,w,timer
End Type

Type bomb
	Field x,y,xspeed#,yspeed#
End Type

Type wolke
	Field x,y,typ
End Type

Type platsch
	Field x,timer
End Type

Type rauch
	Field x#,y#,w,timer,speed#
End Type

Global schiff.schiff,schuss.schuss,bomb.bomb,wolke.wolke,platsch.platsch,rauch.rauch
Global scroll,scale,levelwidth,aktlevel,mh,ms

.menu
FlushMouse
ClsColor 0,0,0
Repeat
	mh=MouseHit(1)
	
	SetFont fonts(2)
	Text 400,50,"Perlenhafen",1
	SetFont fonts(1)
	If Button("Starten",150) Then
		Goto game
	EndIf
	If Button("Mod laden",250) Then
		Repeat
			Cls
			dir=Input("Name: ")+"\"
			If FileType(dir+"\l.png")=1 Then
				For i=0 To 1
					For j=0 To 170
						If jetimg(i,j)<>0 Then FreeImage jetimg(i,j)
					Next
				Next
				For i=0 To 2
					FreeImage schiffimg(i)
					FreeImage wolken(i)
				Next
				FreeImage water
				FreeImage spritz
				FreeImage rauchimg
				Goto load
			EndIf
		Forever
	EndIf
	If Button("Anleitung",350) Then
		ExecFile "readme.txt"
	EndIf
	If Button("Beenden",450) Then
		End
	EndIf
	
	SetFont fonts(0)
	Text 10,580,"Ein Spiel von Christoph Mach aka Eingeproggt anlsslich des BCC22"
	
	WaitTimer timer
	Flip 0:Cls
Forever

.game
FlushKeys
ClsColor 70,120,255
aktlevel=0
LoadMap

Repeat
	ms=MilliSecs()
	
	For wolke=Each wolke
		If wolke\x-scroll>-50 And wolke\x-scroll<850 Then
			DrawImage wolken(wolke\typ),wolke\x-scroll,wolke\y
		EndIf
	Next
	For i=-10 To 810 Step 20
		DrawImage water,i-(scroll Mod 20),600-ImageHeight(water)/2
	Next
	Line 0-scroll,0,0-scroll,600
	Line levelwidth-scroll,0,levelwidth-scroll,600
	
	Rect 10,550,levelwidth/scale+1,40,0
	Color 0,0,255
	Rect 11,583,levelwidth/scale-1,6,1
	Color 255,255,255
	
	i=0
	For schiff=Each schiff
		DrawImage schiffimg(schiff\typ),schiff\x-scroll,500
		If schiff\typ=2 Then
			WritePixel 10+schiff\x/scale,583,65280
		Else
			WritePixel 10+schiff\x/scale,583,0
		EndIf
		balken schiff\x-50-scroll,500-schiff\h/2,schiff\leben,schiff\maxleben,100
		If schiff\typ=2 Then
			;Landen berprfen
			If player\x>schiff\x-schiff\w/2 And player\x<schiff\x+schiff\w/2 Then
				If player\y>=500-schiff\h/3 And player\speed<2 Then
					player\y=500-schiff\h/3
					player\speed=0
					player\schuss=player\schuss+5
					player\bomben=player\bomben+2
					player\leben=player\leben+1
					ok=1
					If player\schuss>500 Then player\schuss=500 Else ok=False
					If player\bomben>50 Then player\bomben=50 Else ok=False
					If player\leben>20 Then player\leben=20 Else ok=False
					If ok Then
						player\y=500-schiff\h/2
						player\speed=3
						player\w=0
					EndIf
				EndIf
			EndIf
		Else
			i=i+1
		EndIf
		If schiff\leben<schiff\maxleben/3 Then
			If Rand(0,(schiff\maxleben/3+schiff\leben)/50)<2 Then
				NRauch schiff\x+Rand(-schiff\w/3,schiff\w/3),500
			EndIf
		EndIf
	Next
	
	If First jet=Last jet And i=0 Then
		aktlevel=aktlevel+1
		If LoadMap()=0 Then Goto menu
	EndIf
	
	For platsch=Each platsch
		DrawImage spritz,platsch\x-scroll,490,platsch\timer*0.1
		platsch\timer=platsch\timer+1
		If platsch\timer>=30 Then Delete platsch
	Next
	
	For schuss=Each schuss
		Oval schuss\x-2-scroll,schuss\y-2,4,4,1
		schuss\x=schuss\x+Cos(schuss\w)*20
		schuss\y=schuss\y+Sin(schuss\w)*20
		schuss\timer=schuss\timer+1
		If schuss\timer>100 Then
			Delete schuss
		Else
			If schuss\y>500 Then
				platsch=New platsch
				platsch\x=schuss\x
				Delete schuss
			Else
				;Kollisionsprfung
				For jet=Each jet
					If Sqr((jet\x-schuss\x)^2+(jet\y-schuss\y)^2)<20 Then
						jet\leben=jet\leben-1
						Delete schuss
						Exit
					EndIf
				Next
			EndIf
		EndIf
	Next
	
	For bomb=Each bomb
		Oval bomb\x-4-scroll,bomb\y-4,8,8,1
		bomb\x=bomb\x+bomb\xspeed
		bomb\y=bomb\y+bomb\yspeed
		bomb\yspeed=bomb\yspeed*1.05
		If bomb\y>500 Then
			platsch=New platsch
			platsch\x=bomb\x
			Delete bomb
		ElseIf bomb\y>450 Then
			;Kollision
			For schiff=Each schiff
				If Abs(schiff\x-bomb\x)<schiff\w/2 And bomb\y>500-schiff\h/3 Then
					schiff\leben=schiff\leben-100
					If schiff\leben<=0 Then Delete schiff
					For i=1 To 5
						NRauch bomb\x,bomb\y
					Next
					Delete bomb
					Exit
				EndIf
			Next
		Else
			For jet=Each jet
				If Abs(jet\x-bomb\x)<40 And Abs(jet\y-bomb\y)<10 Then
					jet\leben=jet\leben-5
					Delete bomb
					Exit
				EndIf
			Next
		EndIf
	Next
	
	For jet.jet=Each jet
		If jet\y<500 Then
			If jet\x-scroll>-50 And jet\x-scroll<850 Then
				DrawImage jetimg(jet\fraktion,jet\w/2),jet\x-scroll,jet\y
				balken jet\x-30-scroll,jet\y-30,jet\leben,jet\maxleben,60
			EndIf
			If jet=player Then
				WritePixel 10+jet\x/scale,550+jet\y/15,65280
			Else
				WritePixel 10+jet\x/scale,550+jet\y/15,16711680
			EndIf
			jet\x=jet\x+Cos(jet\w)*jet\speed
			jet\y=jet\y+Sin(jet\w)*jet\speed
			
			;Oben
			If jet\y<0 Then jet\w=-jet\w:jet\y=1
			
			;Seitliche Begrenzungen
			If jet\x>levelwidth Or jet\x<0 Then jet\w=180-jet\w
			If jet\w<0 Then jet\w=360+jet\w
			
			;Sinkflug
			If jet\speed<5 And Sin(jet\w)>0 Then jet\y=jet\y+Sin(jet\w)*2
			
			;KI
			If jet<>player Then
				If player\y>jet\y-30 And player\y<jet\y+30 Then
					If jet\w<90 Or jet\w>270 Then
						If player\x>jet\x And player\x<jet\x+300 Then NSchuss jet
					Else
						If player\x<jet\x And player\x>jet\x-300 Then NSchuss jet
					EndIf
				EndIf
			EndIf
			
			;Abstrzen
			If jet\leben<=0 Then
				jet\y=jet\y-(jet\leben-1)
				NRauch jet\x,jet\y
				;Kollision mit Schffen
				If jet<>player Then
					For schiff=Each schiff
						If Abs(schiff\x-jet\x)<schiff\w/2 And jet\y>500-schiff\h/3 Then
							schiff\leben=schiff\leben-200
							If schiff\leben<=0 Then Delete schiff
							Delete jet
							Exit
						EndIf
					Next
				EndIf
			EndIf
		Else ;Wasser (=Verrecken)
			platsch=New platsch
			platsch\x=jet\x
			If jet=player Then
				meldung "Leider verloren","Bitte Taste drcken"
				WaitKey
				Goto menu
			EndIf
			Delete jet
		EndIf
	Next
	
	For rauch=Each rauch
		DrawImage rauchimg,rauch\x-scroll,rauch\y
		rauch\x=rauch\x+Cos(rauch\w)*rauch\speed
		rauch\y=rauch\y+Sin(rauch\w)*rauch\speed
		rauch\timer=rauch\timer+1
		If rauch\timer>50 Then Delete rauch
	Next
	
	;Steuerung
	If player\w<90 Or player\w>270 Then ;Nach rechts
		steuerung 1
		
		If player\w<0 Then player\w=358
		If player\w<330 And player\w>270 Then player\w=330
		If player\w>30 And player\w<90 Then player\w=30
	Else ;Nach links
		steuerung -1
		
		If player\w<150 Then player\w=150
		If player\w>210 Then player\w=210
	EndIf
	;Begrenzungen
	If player\speed<0 Then
		player\w=180-player\w
		If player\w<0 Then player\w=360+player\w
		player\speed=player\speed*-1
	EndIf
	If player\speed>10 Then player\speed=10
	;Kmpfen
	If KeyDown(29) And player\schuss>0 Then NSchuss player
	If KeyDown(57) And ms-player\timer>200 And player\bomben>0 Then
		bomb=New bomb
		bomb\x=player\x
		bomb\y=player\y+20
		bomb\xspeed=player\speed*Cos(player\w)
		bomb\yspeed=1
		player\bomben=player\bomben-1
		player\timer=ms
	EndIf
	
	;Spielpause
	If KeyHit(25) Then
		Repeat
			WaitTimer timer
		Until KeyHit(1) Or KeyHit(25)
	EndIf
	
	;HUD
	Text 10,10,"Bomben: "+player\bomben
	Text 10,25,"Schsse: "+player\schuss
	
	scroll=player\x-400
	
	WaitTimer timer
	Flip 0:Cls
Until KeyHit(1)
Goto menu
End

Function LoadJet(t$,index)
	jetimg(index,0)=LoadImage(t+".png")
	For i=1 To 179
		jetimg(index,i)=CopyImage(jetimg(index,0))
		If i>70 And i<110 Then
			ScaleImage jetimg(index,i),-1,1
			RotateImage jetimg(index,i),i*2-180
		ElseIf i<20 Or i>160 Then
			RotateImage jetimg(index,i),i*2
		EndIf
	Next
End Function

Function LoadMap()
	Delete Each jet
	Delete Each schuss
	Delete Each bomb
	Delete Each schiff
	Delete Each wolke
	Delete Each platsch
	Delete Each rauch
	
	Local img=LoadImage(dir+"l.png")
	If aktlevel*20>=ImageHeight(img) Then
		meldung "Gratulation!","Sie haben alle "+aktlevel+" Level bestanden."
		Repeat
			WaitTimer timer
		Until GetKey()<>0 Or MouseHit(1)
		FreeImage img
		Return 0
	EndIf
	meldung "Level "+(aktlevel+1)
	SetBuffer ImageBuffer(img)
	;Info-Pixel. Blauanteil ist Scale-Faktor, Grnanteil ist Levelbreite
	Local col=ReadPixel(0,aktlevel*20)
	scale=col And $FF
	levelwidth=((col And $FF00)/$100)*scale
	For x=0 To levelwidth/scale-1
		For y=aktlevel*20 To aktlevel*20+20
			Select ReadPixel(x,y)
				Case -16744448
					NGeg x*scale,(y-aktlevel*20)*25+10,0
				Case -16711936
					NGeg x*scale,(y-aktlevel*20)*25+10,1
				Case -4144960
					NSchiff x*scale,0
				Case -8355712
					NSchiff x*scale,1
				Case -16711423
					NSchiff x*scale,2
			End Select
		Next
	Next
	FreeImage img
	SetBuffer BackBuffer()
	
	player.jet=New jet
	player\y=300
	player\schuss=500
	player\bomben=50
	player\leben=20
	player\maxleben=player\leben
	player\fraktion=0
	player\speed=3
	
	For i=0 To levelwidth/200
		wolke=New wolke
		wolke\x=Rand(0,levelwidth)
		wolke\y=Rand(50,300)
		wolke\typ=Rand(0,2)
	Next
	
	Return 1
End Function

Function NGeg(x,y,flag)
	jet=New jet
	jet\fraktion=1
	jet\x=x
	jet\y=y
	jet\leben=10
	jet\maxleben=jet\leben
	jet\speed=5
	jet\schuss=500
	jet\w=180*flag
End Function

Function NSchiff(x,typ)
	schiff=New schiff
	schiff\typ=typ
	schiff\leben=(typ+1)*1000
	schiff\maxleben=schiff\leben
	schiff\x=x
	schiff\w=ImageWidth(schiffimg(typ))
	schiff\h=ImageHeight(schiffimg(typ))
End Function

Function NSchuss(j.jet)
	If ms-j\timer>100 Then
		schuss=New schuss
		schuss\y=j\y
		schuss\x=j\x+Cos(j\w)*30
		schuss\w=j\w
		j\timer=ms
		j\schuss=j\schuss-1
	EndIf
End Function

Function NRauch(x,y)
	rauch=New rauch
	rauch\speed=Rnd(0.5,2)
	rauch\w=Rand(260,280)
	rauch\x=x
	rauch\y=y
End Function

Function Button(t$,y)
	Text 400,y,t,1
	If MouseX()>330 And MouseX()<470 And MouseY()>y And MouseY()<y+30 Then
		DrawImage jetimg(0,0),290,y+15
		DrawImage jetimg(0,90),510,y+15
		Return mh
	EndIf
End Function

Function meldung(t$,t2$="")
	Cls
	SetFont fonts(1)
	Text 400,270,t,1,1
	Text 400,300,t2,1,1
	Flip
	Delay 2000
	SetFont fonts(0)
	FlushKeys
End Function

Function balken(x,y,w#,max,gesw)
	Color 255,0,0
	Rect x,y,gesw,5,1
	Color 0,255,0
	Rect x,y,(w/max)*gesw,5,1
	Color 255,255,255
End Function

Function steuerung(faktor)
	If KeyDown(203) Then player\speed=player\speed-0.2*faktor
	If KeyDown(205) Then player\speed=player\speed+0.2*faktor
	If KeyDown(200) Then player\w=(player\w-faktor) Mod 360
	If KeyDown(208) Then player\w=(player\w+faktor) Mod 360
End Function

;~IDEal Editor Parameters:
;~C#Blitz 3D